<template>
    <div>
      <input type="text" v-model="value" @input="handleInput" @blur="handleBlur">
    </div>
</template>

<script>
export default {
  name: 'x-input',
  data() {
    return {
        value: '',
        rawValue: 0, // 存储原始数值，不带单位
        unit: '' // 存储单位，如'm', 'k'等
    };
  },
  computed: {
    // formattedValue: {
    //   get() {
    //     return this.formatValue(this.rawValue);
    //   },
    //   set(value) {
    //     this.parseValue(value);
    //   }
    // }
  },
  mounted() {
  },
  methods: {
    formatValue(value) {
      return (value / Math.pow(10, this.unitMultiplier)).toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    },
    parseValue(value) {
      const match = value.match(/([0-9,.]+)([a-zA-Z]?)/);
      if (match) {
        this.rawValue = parseFloat(match[1].replace(/,/g, ''));
        this.unit = match[2]; // 获取单位，如果有的话
      } else {
        this.rawValue = 0;
        this.unit = '';
      }
    },
    handleInput(event) {
        const regex = /^[0-9bkmBKM]*\.?[0-9bkmBKM]*$/;
        let value = event.target.value
        // 如果输入的值不符合正则规则，则回退到上一次的值
        if (!regex.test(value)) {
            value = this.value;
        }
        // 更新输入框的值
        this.value = value;
        // this.value = event.target.value.replace(/[^0-9bkmBKM.]/g, '')
    },
    handleBlur () {
        console.log('this.value-----', this.value)
        if (this.value.indexOf('b') !== -1) {
            this.value =  (this.value / Math.pow(10, 1000000000)).toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
        }
    }
  }
};
</script>

<style lang="scss" scoped>
</style>